commit 218252f34ce4dad97b3e794b11277f75274a5c2d
parent a19c89902fd32b8a7d1bfe1af856786d8a7499cf
Author: Vetle Haflan <vetle@haflan.dev>
Date: Tue, 4 Aug 2020 00:42:35 +0200
[WIP] Work on some client scripts - to be merged into setup.sh
Everything should actually be integrated in setup.sh already, but the
scripts haven't been tested at all, hence the WIP.
For simpler development and testing, maybe I'll create a CI setup or
something that automatically generates setup.go, just like done with the
HTML. Otherwise all of the scripts can probably be removed when
everything is working correctly.
Diffstat:
6 files changed, 339 insertions(+), 83 deletions(-)
diff --git a/get-events.sh b/client-tools/get-events.sh
diff --git a/report.sh b/client-tools/report.sh
diff --git a/client-tools/sermonic.sh b/client-tools/sermonic.sh
@@ -0,0 +1,74 @@
+# "sermonicronic" report
+# SYNTAX
+# sermonic backup-service /full/path/to/backup-service.sh
+# BEHAVIOR
+# - On success, inlude last 10 or so lines of output (for info about files written etc)
+# OR might want to make that the responsibility of the script being called.
+# - On error, format the details like cronic does
+
+# Based on cronic: https://habilis.net/cronic/
+
+set -e
+
+SERVICEID=$1
+TMP=$(mktemp -d)
+OUT=$TMP/sermonic.out
+ERR=$TMP/sermonic.err
+TRACE=$TMP/sermonic.trace
+FULLDETAILS=$TMP/sermonic.details
+
+out() {
+ echo "$@" >> $FULLDETAILS
+}
+
+json_escape () {
+ printf '%s' "$1" | python -c 'import json,sys; print(json.dumps(sys.stdin.read()))'
+}
+
+
+set +e
+# Run all args after first
+"${@:2}" >$OUT 2>$TRACE
+RESULT=$?
+set -e
+
+# This is just to remove the debug output prefix, I think
+PATTERN="^${PS4:0:1}\\+${PS4:1}"
+if grep -aq "$PATTERN" $TRACE
+then
+ ! grep -av "$PATTERN" $TRACE > $ERR
+else
+ ERR=$TRACE
+fi
+
+if [ $RESULT -ne 0 -o -s "$ERR" ]; then
+ out sermonic detected failure or error output for the service \'$1\'
+ out
+ out FULL COMMAND:
+ out ${@:2}
+ out
+ out RESULT CODE:
+ out $RESULT
+ out
+ out ERROR OUTPUT:
+ out $(cat "$ERR")
+ out
+ out STANDARD OUTPUT:
+ out $(cat "$OUT")
+ if [ $TRACE != $ERR ]
+ then
+ out
+ out "TRACE-ERROR OUTPUT:"
+ out $(cat "$TRACE")
+ fi
+ details=$(json_escape "$(cat $FULLDETAILS)")
+ status=error
+else
+ details=$(json_escape "$(cat $OUT)")
+ status=ok
+fi
+
+sermonicli report $SERVICEID $status "$title" "$details"
+ "$json"
+
+rm -rf "$TMP"
diff --git a/client-tools/sermonicli.sh b/client-tools/sermonicli.sh
@@ -0,0 +1,76 @@
+#!/bin/bash
+
+sermoni=localhost:8080
+# Generate this on server, based on host name:
+#sermoni={{.HostName}}
+TOKEN="$(cat $HOME/.sermoni-token)"
+
+# Prompt for password until the correct one is given
+get_password() {
+ VALIDPW=0
+ while [ $VALIDPW -eq 0 ]; do
+ printf "Password: "
+ read -s PASSWD; echo
+ PASSHASH="$(printf $PASSWD | sha256sum - | awk '{print $1}')"
+ RESPONSE="$(curl -s -H "Pass-Hash: $PASSHASH" $sermoni/services)"
+ if [ -z "$(echo $RESPONSE | grep 'Invalid passphrase')" ]; then
+ VALIDPW=1
+ else
+ echo $RESPONSE
+ echo "Please try again, or press Ctrl+C to exit"
+ fi
+ done
+}
+
+# Prompt for services until no service id is given
+add_services() {
+ echo "Adding new services. Give an empty service ID to exit."
+ while [ true ]; do
+ printf "Service ID (e.g. 'backup-database'): "; read s_id;
+ if [ -z "$s_id" ]; then
+ break
+ fi
+ printf "Service name (e.g. 'Database backup'): "; read s_name;
+ printf "Expectation period (in hours): "; read s_period;
+ printf "Max number of events: "; read s_maxevents;
+ if [ -z "$s_maxevents" ]; then
+ s_maxevents=0
+ fi
+ printf "Service description: "; read s_desc;
+ if [ -z "$s_period" ]; then
+ s_period=0
+ fi
+ payload="{\"token\": \"$TOKEN:$s_id\", \"name\": \"$s_name\", \"maxevents\": $s_maxevents, \"period\": $(($s_period*60*60*1000)), \"description\": \"$s_desc\"}"
+ echo "$payload"
+ curl -s \
+ -H "Content-Type: application/json" \
+ -H "Pass-Hash: $PASSHASH" \
+ -d "$payload" \
+ $sermoni/services
+ done
+}
+
+# Silent for the sake of sermonic. TODO: 'verbose' version
+report_event() {
+ service="$1"; status="$2"; title="$3"; details="$4"
+ token="$(cat $HOME/.sermoni-token):$service"
+ payload="{\"status\": \"$status\", \"title\": \"$title\", \"details\": \"$details\"}"
+ curl -s \
+ -H "Content-Type: application/json" \
+ -H "Service-Token: $token" \
+ -d "$payload" \
+ $sermoni/events
+}
+
+if [ "$1" == "add" ]; then
+ get_password
+ add_services
+elif [ "$1" == "report" ]; then
+ report_event "$2" "$3" "$4" "$5"
+else
+ echo "Usage:"
+ echo " $0 add"
+ echo " Add a new service interactively"
+ echo " $0 report <service ID> <status> <title> <details>"
+ echo " Report an event 'manually'"
+fi
diff --git a/client-tools/setup.sh b/client-tools/setup.sh
@@ -0,0 +1,189 @@
+#/bin/bash
+
+# The easiest way to set up services is to run the following as root / su:
+# $ curl -fsSL {{.HostName}}/setup -o setup.sh
+# $ bash setup.sh
+
+# Generate this on server, based on host name:
+sermoni={{.HostName}}
+
+### Create unique token unless one exists
+if [ ! -f $HOME/.sermoni-token ]; then
+ TOKEN=$(head /dev/urandom | tr -dc A-Za-z0-9 | head -c 16 ; echo '')
+ printf "Server name: "
+ read SERVERNAME
+ TOKEN=$TOKEN-$SERVERNAME
+ printf $TOKEN > $HOME/.sermoni-token
+else
+ TOKEN=$(cat $HOME/.sermoni-token)
+fi
+
+### Install scripts
+
+# Find the first directory in $PATH
+install_sermoni() {
+ IFS=":" read -ra BIN_DIR <<< "$PATH"
+ # TODO: Allow choosing between dirs in $PATH?
+ INSTALL_DIR=$BIN_DIR # Use first path from $PATH
+}
+
+# sermonicli
+cat <<- EOF > $INSTALL_DIR/sermonicli
+#!/bin/bash
+
+sermoni={{.HostName}}
+TOKEN="$(cat $HOME/.sermoni-token)"
+
+# Prompt for password until the correct one is given
+get_password() {
+ VALIDPW=0
+ while [ $VALIDPW -eq 0 ]; do
+ printf "Password: "
+ read -s PASSWD; echo
+ PASSHASH="$(printf $PASSWD | sha256sum - | awk '{print $1}')"
+ RESPONSE="$(curl -s -H "Pass-Hash: $PASSHASH" $sermoni/services)"
+ if [ -z "$(echo $RESPONSE | grep 'Invalid passphrase')" ]; then
+ VALIDPW=1
+ else
+ echo $RESPONSE
+ echo "Please try again, or press Ctrl+C to exit"
+ fi
+ done
+}
+
+# Prompt for services until no service id is given
+add_services() {
+ echo "Adding new services. Give an empty service ID to exit."
+ while [ true ]; do
+ printf "Service ID (e.g. 'backup-database'): "; read s_id;
+ if [ -z "$s_id" ]; then
+ break
+ fi
+ printf "Service name (e.g. 'Database backup'): "; read s_name;
+ printf "Expectation period (in hours): "; read s_period;
+ printf "Max number of events: "; read s_maxevents;
+ if [ -z "$s_maxevents" ]; then
+ s_maxevents=0
+ fi
+ printf "Service description: "; read s_desc;
+ if [ -z "$s_period" ]; then
+ s_period=0
+ fi
+ payload="{\"token\": \"$TOKEN:$s_id\", \"name\": \"$s_name\", \"maxevents\": $s_maxevents, \"period\": $(($s_period*60*60*1000)), \"description\": \"$s_desc\"}"
+ echo "$payload"
+ curl -s \
+ -H "Content-Type: application/json" \
+ -H "Pass-Hash: $PASSHASH" \
+ -d "$payload" \
+ $sermoni/services
+ done
+}
+
+# Silent for the sake of sermonic. TODO: 'verbose' version
+report_event() {
+ service="$1"; status="$2"; title="$3"; details="$4"
+ token="$(cat $HOME/.sermoni-token):$service"
+ payload="{\"status\": \"$status\", \"title\": \"$title\", \"details\": \"$details\"}"
+ curl -s \
+ -H "Content-Type: application/json" \
+ -H "Service-Token: $token" \
+ -d "$payload" \
+ $sermoni/events
+}
+
+if [ "$1" == "add" ]; then
+ get_password
+ add_services
+elif [ "$1" == "report" ]; then
+ report_event "$2" "$3" "$4" "$5"
+else
+ echo "Usage:"
+ echo " $0 add"
+ echo " Add a new service interactively"
+ echo " $0 report <service ID> <status> <title> <details>"
+ echo " Report an event 'manually'"
+fi
+
+ # TODO
+
+EOF
+
+# sermonic
+cat <<- EOF > $INSTALL_DIR/sermonic
+# "sermonicronic" report
+# SYNTAX
+# sermonic backup-service /full/path/to/backup-service.sh
+# BEHAVIOR
+# - On success, inlude last 10 or so lines of output (for info about files written etc)
+# OR might want to make that the responsibility of the script being called.
+# - On error, format the details like cronic does
+
+# Based on cronic: https://habilis.net/cronic/
+
+set -e
+
+SERVICEID=$1
+TMP=$(mktemp -d)
+OUT=$TMP/sermonic.out
+ERR=$TMP/sermonic.err
+TRACE=$TMP/sermonic.trace
+FULLDETAILS=$TMP/sermonic.details
+
+out() {
+ echo "$@" >> $FULLDETAILS
+}
+
+json_escape () {
+ printf '%s' "$1" | python -c 'import json,sys; print(json.dumps(sys.stdin.read()))'
+}
+
+set +e
+# Run all args after first
+"${@:2}" >$OUT 2>$TRACE
+RESULT=$?
+set -e
+
+# This is just to remove the debug output prefix, I think
+PATTERN="^${PS4:0:1}\\+${PS4:1}"
+if grep -aq "$PATTERN" $TRACE
+then
+ ! grep -av "$PATTERN" $TRACE > $ERR
+else
+ ERR=$TRACE
+fi
+
+if [ $RESULT -ne 0 -o -s "$ERR" ]; then
+ out sermonic detected failure or error output for the service \'$1\'
+ out
+ out FULL COMMAND:
+ out ${@:2}
+ out
+ out RESULT CODE:
+ out $RESULT
+ out
+ out ERROR OUTPUT:
+ out $(cat "$ERR")
+ out
+ out STANDARD OUTPUT:
+ out $(cat "$OUT")
+ if [ $TRACE != $ERR ]
+ then
+ out
+ out "TRACE-ERROR OUTPUT:"
+ out $(cat "$TRACE")
+ fi
+ details=$(json_escape "$(cat $FULLDETAILS)")
+ status=error
+else
+ details=$(json_escape "$(cat $OUT)")
+ status=ok
+fi
+
+sermonicli report $SERVICEID $status "$title" "$details"
+ "$json"
+
+rm -rf "$TMP"
+
+EOF
+
+
diff --git a/sermonic.sh b/sermonic.sh
@@ -1,83 +0,0 @@
-# "sermonicronic" report
-# SYNTAX
-# sermonic backup-service /full/path/to/backup-service.sh
-# BEHAVIOR
-# - On success, inlude last 10 or so lines of output (for info about files written etc)
-# OR might want to make that the responsibility of the script being called.
-# - On error, format the details like cronic does
-
-# Based on CRONIC
-# | Cronic v3 - cron job report wrapper
-# | Copyright 2007-2016 Chuck Houpt. No rights reserved, whatsoever.
-# | Public Domain CC0: http://creativecommons.org/publicdomain/zero/1.0/
-
-set -e
-
-SERVICEID=$1
-TMP=$(mktemp -d)
-OUT=$TMP/sermonic.out
-ERR=$TMP/sermonic.err
-TRACE=$TMP/sermonic.trace
-FULLDETAILS=$TMP/sermonic.details
-
-out() {
- echo "$@" >> $FULLDETAILS
-}
-
-json_escape () {
- printf '%s' "$1" | python -c 'import json,sys; print(json.dumps(sys.stdin.read()))'
-}
-
-
-set +e
-# Run all args after first
-"${@:2}" >$OUT 2>$TRACE
-RESULT=$?
-set -e
-
-# This is just to remove the debug output prefix, I think
-PATTERN="^${PS4:0:1}\\+${PS4:1}"
-if grep -aq "$PATTERN" $TRACE
-then
- ! grep -av "$PATTERN" $TRACE > $ERR
-else
- ERR=$TRACE
-fi
-
-if [ $RESULT -ne 0 -o -s "$ERR" ]; then
- out sermonic detected failure or error output for the service \'$1\'
- out
- out FULL COMMAND:
- out ${@:2}
- out
- out RESULT CODE:
- out $RESULT
- out
- out ERROR OUTPUT:
- out $(cat "$ERR")
- out
- out STANDARD OUTPUT:
- out $(cat "$OUT")
- if [ $TRACE != $ERR ]
- then
- out
- out "TRACE-ERROR OUTPUT:"
- out $(cat "$TRACE")
- fi
- details=$(json_escape "$(cat $FULLDETAILS)")
- status=error
-else
- details=$(json_escape "$(cat $OUT)")
- status=ok
-fi
-
-echo "$json"
-
-rm -rf "$TMP"
-
-# Consider moving this part to dedicated smreport script:
-sermoni=http://localhost:8080
-token="$(cat $HOME/.sermoni-token):$SERVICEID"
-JSONDATA="{\"status\": \"$status\", \"title\": \"$title\", \"details\": $details}"
-echo "$JSONDATA"
-curl -H "Service-Token: $token" -d "$JSONDATA" $sermoni/events